function IDE_GetCodeEditor: TCustomControl; var buff:string; begin SetLength(buff,20); if HostCallback('IDE_GetCodeEditor','',buff) then Result:=TCustomControl(StrToIntDef(buff,0)) else Result:=nil; end;

procedure CodeEditor_BeginUpdate; var b:string; begin HostCallback('CodeEditor_BeginUpdate', '', b); end;
procedure CodeEditor_EndUpdate; var b:string; begin HostCallback('CodeEditor_EndUpdate', '', b); end;

function CodeEditor_GetSelText: string; var buff:string; begin if HostCallback('CodeEditor_GetSelText','',buff) then Result:=buff else Result:=''; end;
procedure CodeEditor_SetSelText(const Value: string); var b:string; begin HostCallback('CodeEditor_SetSelText', Value, b); end;

function CodeEditor_GetLineText: string; var buff:string; begin if HostCallback('CodeEditor_GetLineText','',buff) then Result:=buff else Result:=''; end;
procedure CodeEditor_SetLineText(const Value: string); var b:string; begin HostCallback('CodeEditor_SetLineText', Value, b); end;

function CodeEditor_GetSelStart: Integer; var buff:string; begin SetLength(buff,20); if HostCallback('CodeEditor_GetSelStart','',buff) then Result:=StrToIntDef(buff,0) else Result:=0; end;
procedure CodeEditor_SetSelStart(Value: Integer); var b:string; begin HostCallback('CodeEditor_SetSelStart', IntToStr(Value), b); end;

function CodeEditor_GetSelLength: Integer; var buff:string; begin SetLength(buff,20); if HostCallback('CodeEditor_GetSelLength','',buff) then Result:=StrToIntDef(buff,0) else Result:=0; end;
procedure CodeEditor_SetSelLength(Value: Integer); var b:string; begin HostCallback('CodeEditor_SetSelLength', IntToStr(Value), b); end;

function CodeEditor_GetText: string; var buff:string; begin if HostCallback('CodeEditor_GetText','',buff) then Result:=buff else Result:=''; end;
procedure CodeEditor_SetText(const Value: string); var b:string; begin HostCallback('CodeEditor_SetText', Value, b); end;

function CodeEditor_GetCharAtCursor: Char; var buff: string;
begin
  Result:=#0;
  SetLength(buff,1);
  if HostCallback('CodeEditor_GetCharAtCursor','',buff) and (length(buff)>0) then
    Result:=buff[1];
end;

function CodeEditor_GetWordAtCursor: string; var buff: string; begin SetLength(buff,255); if HostCallback('CodeEditor_GetWordAtCursor','',buff) then Result:=buff else Result:=''; end;
function CodeEditor_GetWordAtMouse: string; var buff: string; begin SetLength(buff,255); if HostCallback('CodeEditor_GetWordAtMouse','',buff) then Result:=buff else Result:=''; end;

function CodeEditor_GetLine(Index: Integer): string; var buff: string; begin if HostCallback('CodeEditor_GetLine',IntToStr(Index), buff) then Result:=buff else Result:=''; end;
procedure CodeEditor_SetLine(Index: Integer; const Value: string); var b:string; begin HostCallback('CodeEditor_SetLine', IntToStr(Index)+','+Value, b); end;

procedure CodeEditor_BeginUndoBlock; var b:string; begin HostCallback('CodeEditor_BeginUndoBlock', '', b); end;
procedure CodeEditor_EndUndoBlock; var b:string; begin HostCallback('CodeEditor_EndUndoBlock', '', b); end;

procedure CodeEditor_GetCaretPosXY(var X: Integer; var Y: Integer);
var
  buff:string;
  p:integer;
begin
  x:=1;
  y:=1;
  SetLength(buff,48);
  if HostCallback('CodeEditor_GetCaretPos','',buff) then
  begin
    p:=pos(',',buff);
    if p>0 then
    begin
      x:=StrToIntDef(copy(buff,1,p-1),1);
      y:=StrToIntDef(copy(buff,p+1,maxint),1);
    end;
  end
end;

function CodeEditor_GetCaretPos: TPoint; begin CodeEditor_GetCaretPosXY(Result.X, Result.Y); end;

procedure CodeEditor_SetCaretPosXY(X, Y: Integer); var b:string; begin HostCallback('CodeEditor_SetCaretPos', inttostr(X)+','+IntToStr(Y), b); end;
procedure CodeEditor_SetCaretPos(CPos: TPoint); begin CodeEditor_SetCaretPosXY(CPos.X,CPos.Y); end;

procedure CodeEditor_InvokeCommand(Command: Word; AChar: Char; X, Y: Integer); var b:string; begin HostCallback('CodeEditor_InvokeCommand', IntToStr(Command)+','+AChar+','+IntToStr(X)+','+IntToStr(Y), b); end;
procedure CodeEditor_Changed; var b:string; begin HostCallback('CodeEditor_Changed', '', b); end;